/*
 * 16/9/210
 * @author: kalliopi kravari
 */

import jade.core.*;
import jade.lang.acl.*;
import jade.core.behaviours.CyclicBehaviour;
import java.io.*;
import java.net.*;
import jade.domain.*;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.methods.GetMethod;

public class RRPAgent extends jade.core.Agent {

    private String queryFile, query, xsltFile, content;
    private String response = null;
    private AID sender;

    @Override
    protected void setup() {

        try {
            DFAgentDescription dfd = new DFAgentDescription();
            dfd.setName(getAID());
            //Register the service in the yellow pages as prova reasoning
            ServiceDescription sd = new ServiceDescription();
            sd.setType("Rule_Responder_Proxy");
            sd.setName(getLocalName() + " Service");
            dfd.addServices(sd);
            DFService.register(this, dfd);
        } catch (Exception e) {
            System.out.println(e);
        }
        System.out.println(this.getLocalName() + " has registered as Rule Responder Proxy");

        //Get start-up arguments se periptosi pou theloume na xrisimopoiisoume apeutheias ton proxy kai na min kanoume ena allo prosopiko agent
        Object[] args = getArguments();
        if (args != null) {
            if (args.length == 1) {
                queryFile = args[0].toString();
            }
            if (args.length > 1) {
                queryFile = args[0].toString();
                xsltFile = args[1].toString();//just in case.
            }

        }


        addBehaviour(new HandleInformBehaviour(this));
    }

    class HandleInformBehaviour extends CyclicBehaviour {

        public HandleInformBehaviour(Agent a) {
            super(a);
        }

        public void action() {

            ACLMessage msg = receive();
            if (msg != null) {
                ACLMessage reply = msg.createReply();
                sender = msg.getSender();
                if (msg.getPerformative() == ACLMessage.REQUEST) {
                    System.out.print("RRProxy: Query received..");
                    content = msg.getContent();
                } else {
                    reply.setPerformative(ACLMessage.NOT_UNDERSTOOD);
                    reply.setContent("(Unexpected-act " + ACLMessage.getPerformative(msg.getPerformative()) + ")" + "Expected REQUEST! " + "Try Again!!");
                    send(reply);
                }
                //query process....
                if (content != null) {

                    //send request (ruleml)
                    query = fileToString(content); //reads the file and stores its content to a string
                    if (response == null) {
                        response = sendQuery();
                        System.out.println("Query sent!");
                    }
                    //System.out.println(response);
                    System.out.println("Response received!");
                    String fileName =stringToFile(response);//writes response to a file
                    String RuleMLFilePath = "C:/jade/EMERALD/RRPFiles/" + fileName + ".ruleml";
                    System.out.println(RuleMLFilePath);
                    System.out.println("RuleML file available!");
                    //send answer
                    ACLMessage message = new ACLMessage(ACLMessage.INFORM);
                    message.addReceiver(sender);
                    message.setLanguage("English");
                    message.setContent(RuleMLFilePath);
                    send(message);
                    System.out.println("RRProxy: Answer sent..");
                    response = null;

                }
            }
            //direct use
            if (queryFile != null) {
                System.out.println("Direct use!");
                //send request (ruleml)
                query = fileToString(queryFile); //reads the file and stores its content to a string
                if (response == null) {
                    response = sendQuery();
                    System.out.println("Query sent!");
                }
                System.out.println("Response received!");
                String RuleMLFilePath = stringToFile(response);//writes response to a file
                System.out.println("RuleML file available!");
                xslTransformation(RuleMLFilePath, xsltFile);
                System.out.println("Trasformed file available!");
            }
        }
    }

    //prepares and sends the query
    private String sendQuery() {
        HttpClient client = new HttpClient();
        GetMethod method;
        int statusCode;
        String contents = "";
        try {
            method = new GetMethod("http://155.207.113.24:8888");
            method.setFollowRedirects(true);
            NameValuePair pair1 = new NameValuePair("Horde", "3a466331bca877eeb014be19eee68790");
            NameValuePair pair2 = new NameValuePair("box1", query);
            method.setQueryString(new NameValuePair[]{pair1, pair2});
            statusCode = client.executeMethod(method);
            if (statusCode != -1) {
                contents = contents + method.getResponseBodyAsString();
            }

        } catch (Exception ex) {
            System.out.println("exception" + ex);
        }
        return contents;
    }

    //Reads a file and returns it as String
    private String fileToString(String path) {
        String str = "";
        File file = new File(path);
        Integer length = (int) file.length();
        System.out.println("File length:" + file.length());

        try {
            byte[] data = new byte[length];
            FileInputStream f = null;
            DataInputStream df = null;
            f = new FileInputStream(path);
            df = new DataInputStream(f);
            df.read(data);
            for (int i = 0; i < data.length; i++) {
                str = str + (char) data[i];

            }
            df.close();
            f.close();
        } catch (FileNotFoundException e) {

            System.err.println("There is no such a file...");
        } catch (IOException er) {
        }

        return str;
    }

    //stores a string to a file
    private String stringToFile(String input) {

        String fileName = "response" + randomString();
        String filePath = "C:\\jade\\EMERALD\\RRPFiles/" + fileName + ".ruleml";
        try {
            BufferedWriter out = new BufferedWriter(new FileWriter(filePath));
            out.write(input);
            out.close();
        } catch (IOException e) {
            System.out.println("Exception ");
        }
      return fileName;
    }

    // Returns a random 4-character string:
    // Characters 1-2 are letters, characters 3-4 are numbers
    private String randomString() {
        java.util.Random random = new java.util.Random();
        String rstr = "";
        for (int j = 0; j < 2; j++) {
            int rand = random.nextInt(25);
            rstr += (char) (97 + rand);
        }
        for (int j = 0; j < 2; j++) {
            int rand = random.nextInt(10);
            rstr += (rand);
        }
        return rstr;
    }
// XSL Transformation.
    private void xslTransformation(String ruleml, String xslt) {
        try {
            transform(ruleml, xslt);
        } catch (Exception ex) {
            System.out.println("xslTransformation Exception:");
            System.out.println(ex.getMessage());
            return;
        }
        System.out.println("Message transformed.");
    }

    // Auxilliary method for the xslTransformation method.
    private void transform(String ruleml, String xslt) throws Exception {

        String path = "C:\\jade\\EMERALD\\RRPFiles\\sponsor-levels.rdf";
        // 1. Instantiate a TransformerFactory.
        javax.xml.transform.TransformerFactory tFactory =
                javax.xml.transform.TransformerFactory.newInstance();

        // 2. Use the TransformerFactory to process the stylesheet Source and
        //    generate a Transformer.
        javax.xml.transform.Transformer transformer =
                tFactory.newTransformer(
                new javax.xml.transform.stream.StreamSource(xslt));

        // 3. Use the Transformer to transform an (RuleML) XML Source and send the
        //    output to a Result object.
        transformer.transform(new javax.xml.transform.stream.StreamSource(ruleml),
                new javax.xml.transform.stream.StreamResult(
                new java.io.FileOutputStream(path)));
    }
}
